{*******************************************************}
{                                                       }
{       ֮ HappyViewer  (UFO ļ)      }
{                                                       }
{       Copyright (c) 1999  HappyBird             }
{                                                       }
{*******************************************************}
unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl, StdCtrls, Buttons, Menus, ExtCtrls, ComCtrls, ToolWin, jpeg, UnitConst,
  Disk, Inifiles;

const
  Buffer: array[0..9] of Char = (#$FF, #$D8, #$FF, #$E0, #$0, #$10, #$4A, #$46, #$49, #$46);
  crUP = 15001;
  crDown = 15002;
  crPage = 15003;
type
  TForm1 = class(TForm)
    Panel2: TPanel;
    FileListBox1: TFileListBox;
    Panel1: TPanel;
    DriveComboBox1: TDriveComboBox;
    PopupMenu1: TPopupMenu;
    mnuPercent1: TMenuItem;
    mnuPercent2: TMenuItem;
    mnuPercent3: TMenuItem;
    mnuPercent4: TMenuItem;
    mnuPercent5: TMenuItem;
    mnuPercent6: TMenuItem;
    mnuPercentWidth: TMenuItem;
    mnuPercentHeight: TMenuItem;
    mnuCostum: TMenuItem;
    mnuN1: TMenuItem;
    mnubook2: TMenuItem;
    mnuSetBookMark1: TMenuItem;
    mnuSetBookMark2: TMenuItem;
    mnuSetBookMark3: TMenuItem;
    mnuSetBookMark4: TMenuItem;
    mnuSetBookMark5: TMenuItem;
    Panel3: TPanel;
    Image1: TImage;
    Image2: TImage;
    N1: TMenuItem;
    mnuSaveAs: TMenuItem;
    SaveDialog1: TSaveDialog;
    mnuBookMark: TMenuItem;
    mnuBookMark0: TMenuItem;
    mnuBookMark1: TMenuItem;
    mnuBookMark2: TMenuItem;
    mnuBookMark3: TMenuItem;
    mnuBookMark4: TMenuItem;
    mnuBookMark5: TMenuItem;
    N2: TMenuItem;
    Panel4: TPanel;
    SpeedButton2: TSpeedButton;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Panel5: TPanel;
    SpeedButton3: TSpeedButton;
    SpeedButton1: TSpeedButton;
    Button5: TSpeedButton;
    N3: TMenuItem;
    N4: TMenuItem;
    mnuRotate1: TMenuItem;
    mnuRotate2: TMenuItem;
    mnuRotate3: TMenuItem;
    mnuRotate4: TMenuItem;
    Image7: TImage;
    N5: TMenuItem;
    mnuLock: TMenuItem;
    SpeedButton4: TSpeedButton;
    Panel6: TPanel;
    StatusBar1: TStatusBar;
    DirectoryListBox1: TDirectoryListBox;
    ListTemp: TListBox;
    procedure mnuPercentWidthClick(Sender: TObject);
    procedure mnuPercentHeightClick(Sender: TObject);
    procedure mnuPercentClick(Sender: TObject);
    procedure mnuCostumClick(Sender: TObject);
    procedure mnuSetBookMarkClick(Sender: TObject);
    procedure mnuBookMark1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure JPEGImage1Click(Sender: TObject);
    procedure ChangePosition;
    procedure ChangePicture;
    procedure ChangeImageScale;
    procedure SetScale;
    procedure ReflashBookMark;
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure mnuSaveAsClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PageDown(Sender: TObject);
    procedure PageUp(Sender: TObject);
    procedure ImageDown(Sender: TObject);
    procedure ImageUp(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Play;
    function LoadPicture: Boolean;
    procedure mnuRotate1Click(Sender: TObject);
    procedure Image7MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure mnuLockClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure DirectoryListBox1MouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure ReadIniData;
    procedure StatusBar1Click(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
  private
    WinState: Boolean;
    JPEG: TJPEGImage;
    DragPoint: Tpoint;
    Drag: Boolean;
    AutoPlay: Boolean;
    HaveJPEG: Boolean;
    ImageList: array[0..4] of TImage;
    ImagePoint: Integer;
    ImageEnd: Integer;
    MoveLength: integer;
    ImageRotateAngle: Integer;
    Locked: Boolean;
    PlayPause: Boolean;
    PlayScale: integer;
    Serial: string;
    HaveData: Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses UnitHelp, DataSave;

{$R *.DFM}
{$R cursor.res}

procedure TForm1.mnuPercentWidthClick(Sender: TObject);
begin
  SaveData.ScaleType := Horz;
  mnuPercentWidth.Checked := True;

  ChangeImageScale;
  ChangePosition;
  if SaveData.AutoSave then WriteData;
end;

procedure TForm1.mnuPercentHeightClick(Sender: TObject);
begin
  SaveData.ScaleType := Vert;
  mnuPercentHeight.Checked := True;

  ChangeImageScale;
  ChangePosition;
  if SaveData.AutoSave then WriteData;
end;

procedure TForm1.mnuPercentClick(Sender: TObject);
begin
  SaveData.ScaleType := None;
  SaveData.Scale := (Sender as TMenuItem).Tag;
  (Sender as TMenuItem).Checked := True;
  mnuCostum.Checked := False;
  SetScale;
  ChangeImageScale;
  ChangePosition;
  if SaveData.AutoSave then WriteData;
end;

procedure TForm1.mnuCostumClick(Sender: TObject);
var
  temp: integer;
begin
  SaveData.ScaleType := None;
  mnuCostum.Checked := True;
  temp := strtoint(InputBox(hsCustomScale, hsCustomScaleInput, inttostr(Savedata.Scale)));
  if temp < 25 then
    temp := 25
  else
    if temp > 500 then
      temp := 500;
  if temp = savedata.Scale then exit;
  SaveData.Scale := temp;
  SetScale;

  ChangePicture;
  if SaveData.AutoSave then WriteData;
end;

procedure TForm1.mnuSetBookMarkClick(Sender: TObject);
var
  i: integer;
begin
  i := (Sender as TMenuItem).Tag;
  SaveData.BookMark[i] := FileListBox1.FileName;
  (Sender as TMenuItem).Checked := True;
  ReflashBookMark;
  WriteData;
end;

procedure TForm1.mnuBookMark1Click(Sender: TObject);
var
  i, j: integer;
begin
  i := (Sender as TMenuItem).Tag;
  if SaveData.BookMark[i] = '' then exit;
  if FileExists(SaveData.BookMark[i]) then
  begin
    DriveComboBox1.Drive := SaveData.BookMark[i, 1];
    DirectoryListBox1.Directory := ExtractFilePath(SaveData.BookMark[i]);
    for j := 0 to (FileListBox1.Items.Count - 1) do
      if FileListBox1.Items.Strings[j] = ExtractFileName(SaveData.BookMark[i]) then
      begin
        FileListbox1.ItemIndex := -1;
        FileListbox1.ItemIndex := j;
        ChangePicture;
        break;
      end;
  end
  else
    MessageDlg(hsFileOpenError, mtError, [mbOk], 0);
end;

procedure TForm1.FormShow(Sender: TObject);
var
  i: integer;
  FileName, Dir, FileFullName, Temp: string;
  Drive: Char;
  Buffer, B2: array[0..MAX_PATH - 1] of Char;
  P: PChar;

begin
  Left := 0;
  Top := 0;
  Width := Screen.Width;
  Height := Screen.Height;
  Panel5.Left := Panel3.Width - Panel5.Width; WinState := True;
  JPEG := Tjpegimage.Create;
  ReadData;
  frmHelp.CheckBox2.Checked := SaveData.AutoPage;
  frmHelp.CheckBox1.Checked := SaveData.AutoSave;
  frmHelp.TrackBar1.Position := SaveData.PlayDelay;
  if SaveData.PlayDirection <> 0 then frmHelp.RadioButton2.Checked := True;
  ReflashBookMark;
  SetScale;
  if ParamCount > 0 then
  begin
    P := GetCommandLine();
    if P[0] = '"' then
      P := P + Length(paramstr(0)) + 2
    else
      P := P + Length(paramstr(0));

    while p[0] <= ' ' do
      inc(p);
    FileFullName := P;
  end
  else
    FileFullName := SaveData.BookMark[0];

  if FileExists(FileFullName) then
  begin
    ProcessPath(FileFullName, Drive, Dir, FileName);
    DriveComboBox1.Drive := Drive;
    DirectoryListBox1.Directory := Dir;
    GetShortPathName(PChar(FileName), Buffer, SizeOf(Buffer));
    FileName := buffer;
    for i := 0 to (FileListBox1.Items.Count - 1) do
    begin
      strPCopy(b2, FileListBox1.Items.Strings[i]);
      GetShortPathName(PChar(FileListBox1.Items.Strings[i]), Buffer, SizeOf(Buffer));
      Temp := buffer;
      if UpperCase(FileName) = UpperCase(Temp) then
      begin
        FileListbox1.ItemIndex := -1;
        FileListbox1.ItemIndex := i;
        ChangePicture;
        break;
      end;
    end;
  end
  else
  begin
    DriveComboBox1.Drive := ExtractFilePath(Application.ExeName)[1];
    DirectoryListBox1.Directory := ExtractFilePath(Application.ExeName);
    Image1.Picture := Image2.Picture;
    HaveJPEG := False;
  end; //If fileExists
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i: integer;
begin
  if key = 80 {key 'p'} then Speedbutton3.Click;
  if AutoPlay then
  begin
    case key of
      38: begin // Up Arrow
          if MoveLength > 0 then MoveLength := MoveLength - 1;
          Button5.Top := MoveLength * 10 + 23 - 8;
          if Button5.Top < 23 then Button5.Top := 23;
        end;
      40: begin // Down Arrow
          if MoveLength < 10 then MoveLength := MoveLength + 1;
          Button5.Top := MoveLength * 10 + 23 - 8;
          if Button5.Top > 122 - 8 then Button5.Top := 122 - 8;
        end;
      33: begin //Page UP
          MoveLength := MoveLength - 3;
          if MoveLength < 0 then MoveLength := 0;
          Button5.Top := MoveLength * 10 + 23 - 8;
          if Button5.Top < 23 then Button5.Top := 23;
        end;
      34: begin //Page Down
          if MoveLength < 10 then MoveLength := MoveLength + 3;
          if MoveLength > 10 then MoveLength := 10;
          Button5.Top := MoveLength * 10 + 23 - 8;
          if Button5.Top > 122 - 8 then Button5.Top := 122 - 8;
        end;
      32: begin
          PlayPause := not PlayPause;
        end;
      107, 187: begin //+
          if SaveData.PlayDelay > 25 then SaveData.PlayDelay := SaveData.PlayDelay - 25;
          frmHelp.TrackBar1.Position := SaveData.PlayDelay;
        end;
      109, 189: begin //-
          if SaveData.PlayDelay <= 500 - 25 then SaveData.PlayDelay := SaveData.PlayDelay + 25;
          frmHelp.TrackBar1.Position := SaveData.PlayDelay;
        end;
    end;
  end
  else
  begin
    case key of
      27: begin //Esc
          JPEGImage1Click(nil);
          key := 0;
        end;
      33: begin //Page UP
          PageUP(nil);
          key := 0;
        end;
      34: begin //Page Down
          PageDown(nil);
          key := 0;
        end;
      37: begin //Left arrow
          if Image1.Left < 0 then
          begin
            i := image1.Left + Panel3.Width - 20;
            if i > 0 then i := 0;
            image1.Left := i;
          end;
          key := 0;
        end;
      36, 38: begin //Home,Up Arrow
          ImageUp(nil);
          key := 0;
        end;
      39: begin //Right Arrow
          if Image1.BoundsRect.Right > Panel3.Width then
          begin
            i := image1.Left - Panel3.Width + 20;
            if i < Panel3.Width - Image1.Width then i := Panel3.Width - Image1.Width;
            image1.Left := i;
          end;
          key := 0;
        end;
      32, 35, 40: begin //Space, End, Down Arrow
          ImageDown(nil);
          key := 0;
        end;
      65: //A: AutoPage
        begin
          frmHelp.CheckBox2.Checked := not frmHelp.CheckBox2.Checked;
          SaveData.AutoPage := frmHelp.CheckBox2.Checked;
          key := 0;
        end;
      112: SpeedButton1.Click; //F1
      113: mnuSaveAs.Click; //F2
      115: Close; //F4
      188: mnuRotate1Click(mnuRotate3); //<
      190: mnuRotate1Click(mnuRotate2); //>
    end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  rtMouse: TRect;
begin
  SaveData.BookMark[0] := FileListBox1.FileName;
  JPEG.Destroy;
  if SaveData.AutoSave then WriteData;
  rtMouse := Rect(0, 0, Screen.Width, Screen.Height);
  ClipCursor(@rtMouse);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  if SaveData.ScaleType <> None then ChangeImageScale;
  ChangePosition;
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
begin
  ChangePicture;
end;

procedure TForm1.JPEGImage1Click(Sender: TObject);
begin
  WinState := not (WinState);
  Panel2.Visible := WinState;
  if not (WinState) then
    if Form1.WindowState = wsNormal then
      Form1.WindowState := wsMaximized;
  ChangeImageScale;
  ChangePosition;
end;

procedure TForm1.ChangePosition;
begin
  Image1.Left := (Panel3.Width - Image1.Width) div 2;
  if Image1.Left < 0 then Image1.Left := 0;
  Image1.Top := (Panel3.Height - Image1.Height) div 2;
  if Image1.Top < 0 then Image1.Top := 0;
end;

procedure Tform1.ChangePicture;
begin
  if FileListbox1.FileName = '' then
    exit;
  if LoadPicture then
  begin
    if Locked and (ImageRotateAngle <> 0) then
      mnuRotate1Click(mnuLock)
    else
    begin
      Image1.Picture.Graphic := JPEG;
      ImageRotateAngle := 0;
    end;
    ChangeImageScale;
    ChangePosition;
    Form1.Caption := FormCaption + FileListBox1.FileName;
  end
  else
  begin
    MessageDlg(hsFileError, mtError, [mbOk], 0);
    Image1.Picture := Image2.Picture;
    Image1.BoundsRect := Image2.BoundsRect;
    ChangePosition;
    Form1.Caption := FormCaption;
  end;
end;

procedure TForm1.ChangeImageScale;
begin
  if not HaveJPEG then
  begin
    Image1.BoundsRect := Image2.BoundsRect;
    exit;
  end;
  case ImageRotateAngle of
    0, 180:
      case SaveData.ScaleType of
        None:
          begin
            Image1.Width := JPEG.Width * SaveData.Scale div 100;
            Image1.Height := JPEG.Height * SaveData.Scale div 100;
          end;
        Horz:
          begin
            if JPEG.Width = 0 then exit;
            SaveData.Scale := 100 * Panel3.Width div JPEG.Width;
            Image1.Width := JPEG.Width * SaveData.Scale div 100;
            Image1.Height := JPEG.Height * SaveData.Scale div 100;
          end;
        Vert:
          begin
            if JPEG.height = 0 then exit;
            SaveData.Scale := 100 * Panel3.Height div JPEG.Height;
            Image1.Width := JPEG.Width * SaveData.Scale div 100;
            Image1.Height := JPEG.Height * SaveData.Scale div 100;
          end;
      end;
  else
    case SaveData.ScaleType of
      None:
        begin
          Image1.Height := JPEG.Width * SaveData.Scale div 100;
          Image1.Width := JPEG.Height * SaveData.Scale div 100;
        end;
      Horz:
        begin
          if JPEG.Width = 0 then exit;
          SaveData.Scale := 100 * Panel3.Width div JPEG.Height;
          Image1.Height := JPEG.Width * SaveData.Scale div 100;
          Image1.Width := JPEG.Height * SaveData.Scale div 100;
        end;
      Vert:
        begin
          if JPEG.height = 0 then exit;
          SaveData.Scale := 100 * Panel3.Height div JPEG.Width;
          Image1.Height := JPEG.Width * SaveData.Scale div 100;
          Image1.Width := JPEG.Height * SaveData.Scale div 100;
        end;
    end;
  end;
end;

procedure TForm1.SetScale;
begin
  SaveData.StandardScale := False;
  case SaveData.Scale of
    25: mnuPercent1.Checked := True;
    50: mnuPercent2.Checked := True;
    75: mnuPercent3.Checked := True;
    100: begin
        mnuPercent4.Checked := True;
        SaveData.StandardScale := True;
      end;
    150: mnuPercent5.Checked := True;
    200: mnuPercent6.Checked := True;
  else
    mnuCostum.Checked := True;
  end;
end;

procedure TForm1.ReflashBookMark;
begin
  mnuSetBookMark1.Checked := (SaveData.BookMark[1] <> '');
  mnuSetBookMark2.Checked := (SaveData.BookMark[2] <> '');
  mnuSetBookMark3.Checked := (SaveData.BookMark[3] <> '');
  mnuSetBookMark4.Checked := (SaveData.BookMark[4] <> '');
  mnuSetBookMark5.Checked := (SaveData.BookMark[5] <> '');
  mnuBookMark0.Caption := 'ϴ˳:' + SaveData.BookMark[0];
  mnuBookMark1.Caption := 'ǩ1:' + SaveData.BookMark[1];
  mnuBookMark2.Caption := 'ǩ2:' + SaveData.BookMark[2];
  mnuBookMark3.Caption := 'ǩ3:' + SaveData.BookMark[3];
  mnuBookMark4.Caption := 'ǩ4:' + SaveData.BookMark[4];
  mnuBookMark5.Caption := 'ǩ5:' + SaveData.BookMark[5];
end;

procedure TForm1.DirectoryListBox1Change(Sender: TObject);
begin
  Image1.Picture := Image2.Picture;
  Image1.BoundsRect := Image2.BoundsRect;
  ChangePosition;
  HaveJPEG := False;
  Form1.Caption := FormCaption;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  SpeedButton1.Down := True;
  frmHelp.showModal;
  SpeedButton1.Down := False;
end;

procedure TForm1.mnuSaveAsClick(Sender: TObject);
begin
  if HaveJPEG and SaveDialog1.Execute then
    JPEG.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Drag := true;
  DragPoint.x := x;
  DragPoint.y := y;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if drag then
  begin
    Image1.Left := Image1.Left - DragPoint.x + x;
    Image1.top := Image1.Top - dragPoint.y + y;
  end;

end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  drag := false;
end;

procedure TForm1.PageDown(Sender: TObject);
begin
  if FileListbox1.ItemIndex < FileListBox1.Items.Count - 1 then
  begin
    FileListbox1.ItemIndex := FileListbox1.ItemIndex + 1;
    ChangePicture;
  end;
end;

procedure TForm1.PageUp(Sender: TObject);
begin
  if FileListbox1.ItemIndex > 0 then
  begin
    FileListbox1.ItemIndex := FileListbox1.ItemIndex - 1;
    ChangePicture;
  end;
end;

procedure TForm1.ImageDown(Sender: TObject);
var
  i: integer;
begin
  if Image1.BoundsRect.Bottom > Panel3.BoundsRect.Bottom then
  begin
    i := image1.top - Panel3.Height + 20;
    if i < Panel3.Height - Image1.Height then
    begin
      i := Panel3.Height - image1.Height;
    end;
    image1.Top := i;
  end
  else
    if SaveData.AutoPage and (FileListbox1.ItemIndex < FileListBox1.Items.Count - 1) then
    begin
      FileListbox1.ItemIndex := FileListbox1.ItemIndex + 1;
      ChangePicture;
    end;
end;

procedure TForm1.ImageUp(Sender: TObject);
var
  i: integer;
begin
  if Image1.Top < 0 then
  begin
    i := image1.top + Panel3.Height - 20;
    if i > 0 then
    begin
      i := 0;
    end;
    image1.Top := i;
  end
  else if SaveData.AutoPage and (FileListbox1.ItemIndex > 0) then
  begin
    FileListbox1.ItemIndex := FileListbox1.ItemIndex - 1;
    ChangePicture;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Screen.Cursors[crUp] := LoadCursor(HInstance, 'up');
  Screen.Cursors[crDown] := LoadCursor(HInstance, 'down');
  Screen.Cursors[crPage] := LoadCursor(HInstance, 'page');
  SpeedButton3.Glyph.LoadFromResourceName(HInstance, 'Play');

  Image3.Cursor := crUp;
  Image4.Cursor := crDown;
  Image5.Cursor := crPage;
  Image6.Cursor := crPage;
  AutoPlay := False;
  Locked := False;
  HaveJPEG := False;

end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if FileListBox1.FileName = '' then exit;
  MoveLength := 0;
  PlayPause := False;

  AutoPlay := not AutoPlay;
  if AutoPlay then Play;
end;

procedure TForm1.SpeedButton3MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  MoveLength := 0;
  Button5.Top := 23;
end;

procedure TForm1.Play;
var
  i, j: Integer;
  rtMouse: TRect;
begin
  if not HaveJPEG then exit;
  Panel2.Visible := False;
  Image1.Visible := False;
  Image3.Visible := False;
  Image4.Visible := False;
  Image5.Visible := False;
  Image6.Visible := False;

  Panel5.Height := 122;
  SpeedButton3.Glyph.LoadFromResourceName(HInstance, 'Stop');
  SpeedButton3.Hint := 'ֹͣ(P)';
  ImagePoint := 0;
  ImageEnd := 1;

  if SaveData.ScaleType <> None then
    PlayScale := 100
  else
    PlayScale := SaveData.Scale;

  ImageList[ImagePoint] := TImage.Create(nil);
  ImageList[ImagePoint].parent := panel3;
  ImageList[ImagePoint].AutoSize := False;
  ImageList[ImagePoint].Stretch := True;
  ImageList[ImagePoint].Width := JPEG.Width * PlayScale div 100;
  ImageList[ImagePoint].Height := JPEG.Height * PlayScale div 100;
  ImageList[ImagePoint].Picture.Graphic := JPEG; /////
  if SaveData.PlayDirection = 0 then
  begin
    ImageList[ImagePoint].top := 0;
    ImageList[ImagePoint].Left := (Panel3.Width - ImageList[ImagePoint].Width) div 2;
  end
  else
  begin
    ImageList[ImagePoint].Left := 0;
    ImageList[ImagePoint].Top := (Panel3.Height - ImageList[ImagePoint].Height) div 2;
  end;
  rtMouse := Panel5.BoundsRect;
  MapWindowPoints(handle, 0, rtMouse, 2); // 껻
  ClipCursor(@rtMouse); // ƻƶ

  repeat
    begin
      i := ImagePoint;
      j := ImageEnd;
      if SaveData.PlayDelay <> 0 then Sleep(SaveData.PlayDelay);
      repeat
        if SaveData.PlayDirection = 0 then
        begin
          if not PlayPause then
            ImageList[i].Top := ImageList[i].Top - MoveLength;
          if ImageList[i].BoundsRect.Bottom < 0 then
          begin
            ImageList[i].Destroy;
            ImagePoint := (ImagePoint + 1) mod 5;
          end;
          if (ImageList[i].BoundsRect.Bottom < Panel3.Height) and (imageend = (i + 1) mod 5) and (ImagePoint <> ImageEnd) then
          begin
            j := (ImageEnd + 1) mod 5;
            ImageList[(i + 1) mod 5] := TImage.Create(nil);
            ImageList[(i + 1) mod 5].Parent := Panel3;
            ImageList[(i + 1) mod 5].AutoSize := False;
            ImageList[(i + 1) mod 5].Stretch := True;
            if FileListbox1.ItemIndex < FileListBox1.Items.Count - 1 then
              FileListbox1.ItemIndex := FileListbox1.ItemIndex + 1
            else
            begin
              MoveLength := 0;
              AutoPlay := False;
            end;
            if LoadPicture then
            begin
              ImageList[(i + 1) mod 5].Width := JPEG.Width * PlayScale div 100;
              ImageList[(i + 1) mod 5].Height := JPEG.Height * PlayScale div 100;
              ImageList[(i + 1) mod 5].Picture.Graphic := JPEG; /////
            end

            else
            begin
              rtMouse := Rect(0, 0, Screen.Width, Screen.Height);
              ClipCursor(@rtMouse);
              MessageDlg(hsFileError, mtError, [mbOk], 0);
              AutoPlay := False;
              ImageList[(i + 1) mod 5].Picture := Image2.Picture;
            end;
            ImageList[(i + 1) mod 5].Top := ImageList[i].BoundsRect.Bottom;
            ImageList[(i + 1) mod 5].Left := (Panel3.Width - ImageList[(i + 1) mod 5].Width) div 2;
            Form1.Caption := FormCaption + FileListBox1.FileName;
          end;
          i := (i + 1) mod 5;
        end
        else
        begin
          if not PlayPause then
            ImageList[i].Left := ImageList[i].Left - MoveLength; /////
          if ImageList[i].BoundsRect.Right < 0 then /////
          begin
            ImageList[i].Destroy;
            ImagePoint := (ImagePoint + 1) mod 5;
          end;
          if (ImageList[i].BoundsRect.Right < Panel3.Width) and (imageend = (i + 1) mod 5) and (ImagePoint <> ImageEnd) then /////
          begin
            j := (ImageEnd + 1) mod 5;
            ImageList[(i + 1) mod 5] := TImage.Create(nil);
            ImageList[(i + 1) mod 5].Parent := Panel3;
            ImageList[(i + 1) mod 5].AutoSize := False;
            ImageList[(i + 1) mod 5].Stretch := True;
            if FileListbox1.ItemIndex < FileListBox1.Items.Count - 1 then
              FileListbox1.ItemIndex := FileListbox1.ItemIndex + 1
            else
            begin
              MoveLength := 0;
              AutoPlay := False;
            end;
            if LoadPicture then
            begin
              ImageList[(i + 1) mod 5].Width := JPEG.Width * PlayScale div 100;
              ImageList[(i + 1) mod 5].Height := JPEG.Height * PlayScale div 100;

              ImageList[(i + 1) mod 5].Picture.Graphic := JPEG; /////
            end
            else
            begin
              rtMouse := Rect(0, 0, Screen.Width, Screen.Height);
              ClipCursor(@rtMouse);
              MessageDlg(hsFileError, mtError, [mbOk], 0);
              AutoPlay := False;
              ImageList[(i + 1) mod 5].Picture := Image2.Picture;
            end;
            ImageList[(i + 1) mod 5].Left := ImageList[i].BoundsRect.Right; /////
            ImageList[(i + 1) mod 5].Top := (Panel3.Height - ImageList[(i + 1) mod 5].Height) div 2; /////
            Form1.Caption := FormCaption + FileListBox1.FileName;
          end;
          i := (i + 1) mod 5;
        end;
      until i = ImageEnd;
      ImageEnd := j;
      Application.ProcessMessages;
    end;
  until not AutoPlay;
  Panel5.Height := 22;
  SpeedButton3.Glyph.LoadFromResourceName(HInstance, 'Play');
  SpeedButton3.Hint := '(P)';
  i := ImagePoint;
  repeat
    ImageList[i].DesTroy;
    i := (i + 1) mod 5;
  until i = ImageEnd;
  MoveLength := 1;
  ChangePicture;
  Panel2.Visible := WinState;
  Image1.Visible := True;
  Image3.Visible := True;
  Image4.Visible := True;
  Image5.Visible := True;
  Image6.Visible := True;

  rtMouse := Rect(0, 0, Screen.Width, Screen.Height);
  ClipCursor(@rtMouse);
end;

procedure TForm1.mnuRotate1Click(Sender: TObject);
var
  i, j, k, BitPerPixel: integer;
  TempBitmap, TempBitmap2: TBitmap;
  P1, P2: array[0..3000] of PByteArray;

begin
  if not HaveJPEG then
    exit;
  if (Sender as TMenuItem).Tag = -1 then
  begin
    ImageRotateAngle := 0;
    Image1.Picture.Graphic := JPEG;
    ChangeImageScale;
    ChangePosition;
  end
  else
  begin
    TempBitmap := TBitmap.Create;
    TempBitmap2 := TBitmap.Create;
    TempBitmap.Assign(JPEG);
    if TempBitmap.Height > 3000 then exit;
    TempBitmap2.Assign(TempBitmap);
    TempBitmap2.Height := TempBitmap2.Height + 1;
    TempBitmap2.Height := TempBitmap2.Height - 1;
    case tempbitmap.pixelformat of
      pf15bit, pf16bit: BitPerPixel := 2;
      pf24bit: BitPerPixel := 3;
      pf32bit: BitPerPixel := 4;
    else
      BitPerPixel := 1;
    end;
    Screen.Cursor := crHourGlass;
    ImageRotateAngle := (ImageRotateAngle + (Sender as TMenuItem).Tag) mod 360;
    case ImageRotateAngle of
      90:
        begin
          TempBitmap2.Width := TempBitmap.Height; ;
          TempBitmap2.Height := TempBitmap.Width;
          for i := 0 to TempBitmap.Height - 1 do
            p1[i] := TempBitmap.ScanLine[i];
          for i := 0 to TempBitmap2.Height - 1 do
            p2[i] := TempBitmap2.ScanLine[i];
          for i := 0 to TempBitmap2.Height - 1 do
            for j := 0 to TempBitmap2.Width - 1 do
              for k := 0 to BitPerPixel - 1 do
                p2[i] [j * BitPerPixel + k] := p1[TempBitmap.Height - j - 1] [i * BitPerPixel + k];
        end;
      180:
        begin
          for i := 0 to TempBitmap.Height - 1 do
            p1[i] := TempBitmap.ScanLine[i];
          for i := 0 to TempBitmap2.Height - 1 do
            p2[i] := TempBitmap2.ScanLine[i];
          for i := 0 to TempBitmap2.Height - 1 do
            for j := 0 to TempBitmap2.Width - 1 do
              for k := 0 to BitPerPixel - 1 do
                p2[i] [j * BitPerPixel + k] := p1[TempBitmap.Height - i - 1] [(TempBitmap.Width - j - 1) * BitPerPixel + k];
        end;
      270:
        begin
          TempBitmap2.Width := TempBitmap.Height; ;
          TempBitmap2.Height := TempBitmap.Width;
          for i := 0 to TempBitmap.Height - 1 do
            p1[i] := TempBitmap.ScanLine[i];
          for i := 0 to TempBitmap2.Height - 1 do
            p2[i] := TempBitmap2.ScanLine[i];
          for i := 0 to TempBitmap2.Height - 1 do
            for j := 0 to TempBitmap2.Width - 1 do
              for k := 0 to BitPerPixel - 1 do
                p2[i] [j * BitPerPixel + k] := p1[j] [(TempBitmap.Width - i - 1) * BitPerPixel + k];
        end;
    end; //Case
    Image1.Picture.Graphic := TempBitmap2;
    ChangeImageScale;
    ChangePosition;
    Screen.Cursor := crDefault;
    TempBitmap.Destroy;
    TempBitmap2.Destroy;
  end; //if else
end;

procedure TForm1.Image7MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  MoveLength := (Y - 23) div 10 + 1;
  Button5.Top := Y - 4;
  if Button5.Top < 23 then Button5.Top := 23;
  if Button5.Top > 122 - 8 then Button5.Top := 122 - 8;
end;

procedure TForm1.mnuLockClick(Sender: TObject);
begin
  mnuLock.Checked := not mnuLock.Checked;
  Locked := mnuLock.Checked;
end;

function Tform1.LoadPicture: Boolean;
var
  M: TMemoryStream;
  S: string;
begin
  if FileListbox1.FileName = '' then
  begin
    HaveJPEG := False;
    Result := False;
    exit;
  end;
  try
    S := FileListBox1.FileName;
    M := TMemoryStream.Create;
    try
      M.LoadFromFile(FileListBox1.FileName);
      if LowerCase(Copy(S, Length(S) - 2, 3)) = 'ufo' then
        M.WriteBuffer(Buffer, 10);
      M.Seek(0, soFromBeginning);
      JPEG.LoadFromStream(M);
      if (JPEG.Width <> 0) and (JPEG.Height <> 0) then HaveJPEG := True else HaveJPEG := False;
    finally
      M.Destroy;
    end;
  except
    HaveJPEG := False;
  end;
  Result := HaveJPEG;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  frmDisk.Show;
end;

procedure TForm1.DirectoryListBox1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  APoint: TPoint;
  Index: Integer;
  S: string;
begin
  APoint.x := X;
  APoint.y := Y;
  Index := DirectoryListBox1.ItemAtPos(APoint, True);
  if Index = -1 then StatusBar1.SimpleText := ''
  else
    if Index = 0 then StatusBar1.SimpleText := ListTemp.Items.Values['']
    else
    begin
      S := DirectoryListBox1.GetItemPath(Index);
      S := Copy(S, 3, Length(S));
      StatusBar1.SimpleText := ListTemp.Items.Values[s];
    end;
end;

procedure TForm1.ReadIniData;
var
  IniFile: TIniFile;
  i: Integer;
begin
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'ufo-cd.ini');
  ListTemp.Clear;
  IniFile.ReadSections(ListTemp.Items);
  for i := 0 to ListTemp.Items.Count - 1 do
    if ListTemp.Items.Strings[i] = Serial then
    begin
      ListTemp.Clear;
      IniFile.ReadSectionValues(Serial, ListTemp.Items);
      HaveData := True;
      break;
    end;
  IniFile.Destroy;
end;

procedure TForm1.StatusBar1Click(Sender: TObject);
begin
  ReadIniData;
end;

procedure TForm1.DriveComboBox1Change(Sender: TObject);
var
  num1, num2, num3: DWord;
  Buffer: array[0..255] of Char;
  drive, s: string;
begin
  drive := DriveComboBox1.Items.Strings[DriveComboBox1.ItemIndex];
  drive := drive[1] + ':\';
  if not GetVolumeInformation(PChar(drive), buffer, 255, @num1, num2, num3, nil, 0) then exit;
  S := IntToHex(num1 div 65536, 4) + '-' + IntToHex(num1 mod 65536, 4);
//  S := Format('%4x', [num1 div 65536]) + '-' + Format('%.4x', [num1 mod 65536]);
  if S = Serial then Exit;
  Serial := S;
  HaveData := False;
  if GetDriveType(PChar(drive)) = DRIVE_CDROM then ReadIniData;
  Statusbar1.Visible := HaveData;
end;

end.

